// Autogenerated from Pigeon (v3.1.6), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@protocol FlutterMessageCodec;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, FlutterGender) {
  FlutterGenderFemale = 0,
  FlutterGenderMale = 1,
  FlutterGenderNone = 2,
};

typedef NS_ENUM(NSUInteger, FlutterCardType) {
  FlutterCardTypeQr = 0,
  FlutterCardTypeMemberCard = 1,
};

typedef NS_ENUM(NSUInteger, FlutterTransactionRequestType) {
  FlutterTransactionRequestTypeGrant = 0,
  FlutterTransactionRequestTypeSpend = 1,
  FlutterTransactionRequestTypeAll = 2,
};

typedef NS_ENUM(NSUInteger, FlutterTransactionType) {
  FlutterTransactionTypeGrant = 0,
  FlutterTransactionTypeSpend = 1,
  FlutterTransactionTypeReturnGrant = 2,
  FlutterTransactionTypeReturnSpend = 3,
};

typedef NS_ENUM(NSUInteger, FlutterAccountingType) {
  FlutterAccountingTypeDebit = 0,
  FlutterAccountingTypeCredit = 1,
};

typedef NS_ENUM(NSUInteger, FlutterStatus) {
  FlutterStatusInit = 0,
  FlutterStatusInitFailure = 1,
  FlutterStatusNoAccounting = 2,
  FlutterStatusAccountingSuccess = 3,
  FlutterStatusAccountingFailure = 4,
  FlutterStatusAccounting = 5,
};

@class CommonResult;
@class FlutterLoyaltyConfigurationResult;
@class FlutterLoyaltyConfiguration;
@class FlutterRegisterMemberRequest;
@class FlutterRegisterMemberResult;
@class FlutterRegisterMember;
@class FlutterMembershipQrResult;
@class FlutterMembershipQr;
@class FlutterMemberInfoRequest;
@class FlutterMemberInfoResult;
@class FlutterMemberInfo;
@class FlutterTransactionHistoryRequest;
@class FlutterTransactionHistoryResult;
@class FlutterTransactionHistory;
@class FlutterTransaction;
@class FlutterPagination;
@class FlutterNetworkConfigResult;
@class FlutterNetworkConfig;
@class FlutterTier;
@class FlutterClientIdResult;

@interface CommonResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@end

@interface FlutterLoyaltyConfigurationResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code
    loyaltyConfiguration:(nullable FlutterLoyaltyConfiguration *)loyaltyConfiguration;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, strong, nullable) FlutterLoyaltyConfiguration * loyaltyConfiguration;
@end

@interface FlutterLoyaltyConfiguration : NSObject
+ (instancetype)makeWithUrl:(nullable NSString *)url
    bffUrl:(nullable NSString *)bffUrl
    merchantCode:(nullable NSString *)merchantCode
    clientId:(nullable NSString *)clientId
    iamAudience:(nullable NSString *)iamAudience
    linkMembershipUrl:(nullable NSString *)linkMembershipUrl
    registerMemberUrl:(nullable NSString *)registerMemberUrl
    allowLinkMembership:(nullable NSNumber *)allowLinkMembership
    allowRegisterMembership:(nullable NSNumber *)allowRegisterMembership
    membershipCodeFormat:(nullable NSString *)membershipCodeFormat;
@property(nonatomic, copy, nullable) NSString * url;
@property(nonatomic, copy, nullable) NSString * bffUrl;
@property(nonatomic, copy, nullable) NSString * merchantCode;
@property(nonatomic, copy, nullable) NSString * clientId;
@property(nonatomic, copy, nullable) NSString * iamAudience;
@property(nonatomic, copy, nullable) NSString * linkMembershipUrl;
@property(nonatomic, copy, nullable) NSString * registerMemberUrl;
@property(nonatomic, strong, nullable) NSNumber * allowLinkMembership;
@property(nonatomic, strong, nullable) NSNumber * allowRegisterMembership;
@property(nonatomic, copy, nullable) NSString * membershipCodeFormat;
@end

@interface FlutterRegisterMemberRequest : NSObject
+ (instancetype)makeWithPhone:(nullable NSString *)phone
    name:(nullable NSString *)name
    address:(nullable NSString *)address
    dateOfBirth:(nullable NSString *)dateOfBirth
    email:(nullable NSString *)email
    gender:(FlutterGender)gender
    idCardNumber:(nullable NSString *)idCardNumber
    idCitizenNumber:(nullable NSString *)idCitizenNumber
    passportNumber:(nullable NSString *)passportNumber;
@property(nonatomic, copy, nullable) NSString * phone;
@property(nonatomic, copy, nullable) NSString * name;
@property(nonatomic, copy, nullable) NSString * address;
@property(nonatomic, copy, nullable) NSString * dateOfBirth;
@property(nonatomic, copy, nullable) NSString * email;
@property(nonatomic, assign) FlutterGender gender;
@property(nonatomic, copy, nullable) NSString * idCardNumber;
@property(nonatomic, copy, nullable) NSString * idCitizenNumber;
@property(nonatomic, copy, nullable) NSString * passportNumber;
@end

@interface FlutterRegisterMemberResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code
    registerMember:(nullable FlutterRegisterMember *)registerMember;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, strong, nullable) FlutterRegisterMember * registerMember;
@end

@interface FlutterRegisterMember : NSObject
+ (instancetype)makeWithMemberId:(nullable NSString *)memberId;
@property(nonatomic, copy, nullable) NSString * memberId;
@end

@interface FlutterMembershipQrResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code
    membershipQr:(nullable FlutterMembershipQr *)membershipQr;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, strong, nullable) FlutterMembershipQr * membershipQr;
@end

@interface FlutterMembershipQr : NSObject
+ (instancetype)makeWithQrData:(nullable NSString *)qrData
    issueAt:(nullable NSNumber *)issueAt
    expireAt:(nullable NSNumber *)expireAt;
@property(nonatomic, copy, nullable) NSString * qrData;
@property(nonatomic, strong, nullable) NSNumber * issueAt;
@property(nonatomic, strong, nullable) NSNumber * expireAt;
@end

@interface FlutterMemberInfoRequest : NSObject
+ (instancetype)makeWithPhone:(nullable NSString *)phone
    memberQrCode:(nullable NSString *)memberQrCode;
@property(nonatomic, copy, nullable) NSString * phone;
@property(nonatomic, copy, nullable) NSString * memberQrCode;
@end

@interface FlutterMemberInfoResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code
    flutterMemberInfo:(nullable FlutterMemberInfo *)flutterMemberInfo;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, strong, nullable) FlutterMemberInfo * flutterMemberInfo;
@end

@interface FlutterMemberInfo : NSObject
+ (instancetype)makeWithMemberQrCode:(nullable NSString *)memberQrCode
    memberId:(nullable NSString *)memberId
    phone:(nullable NSString *)phone
    memberCardId:(nullable NSString *)memberCardId
    name:(nullable NSString *)name
    isActive:(nullable NSNumber *)isActive
    point:(nullable NSNumber *)point
    tierPoint:(nullable NSNumber *)tierPoint
    keepTierUntil:(nullable NSNumber *)keepTierUntil
    accumulationFrom:(nullable NSNumber *)accumulationFrom
    accumulationTo:(nullable NSNumber *)accumulationTo
    currentTierCode:(nullable NSString *)currentTierCode
    currentTierName:(nullable NSString *)currentTierName
    currentTierMinPoint:(nullable NSNumber *)currentTierMinPoint
    nextTierName:(nullable NSString *)nextTierName
    nextTierMinPoint:(nullable NSNumber *)nextTierMinPoint
    defaultCardType:(FlutterCardType)defaultCardType;
@property(nonatomic, copy, nullable) NSString * memberQrCode;
@property(nonatomic, copy, nullable) NSString * memberId;
@property(nonatomic, copy, nullable) NSString * phone;
@property(nonatomic, copy, nullable) NSString * memberCardId;
@property(nonatomic, copy, nullable) NSString * name;
@property(nonatomic, strong, nullable) NSNumber * isActive;
@property(nonatomic, strong, nullable) NSNumber * point;
@property(nonatomic, strong, nullable) NSNumber * tierPoint;
@property(nonatomic, strong, nullable) NSNumber * keepTierUntil;
@property(nonatomic, strong, nullable) NSNumber * accumulationFrom;
@property(nonatomic, strong, nullable) NSNumber * accumulationTo;
@property(nonatomic, copy, nullable) NSString * currentTierCode;
@property(nonatomic, copy, nullable) NSString * currentTierName;
@property(nonatomic, strong, nullable) NSNumber * currentTierMinPoint;
@property(nonatomic, copy, nullable) NSString * nextTierName;
@property(nonatomic, strong, nullable) NSNumber * nextTierMinPoint;
@property(nonatomic, assign) FlutterCardType defaultCardType;
@end

@interface FlutterTransactionHistoryRequest : NSObject
+ (instancetype)makeWithFromTime:(nullable NSString *)fromTime
    toTime:(nullable NSString *)toTime
    txnType:(FlutterTransactionRequestType)txnType
    page:(nullable NSNumber *)page
    pageSize:(nullable NSNumber *)pageSize;
@property(nonatomic, copy, nullable) NSString * fromTime;
@property(nonatomic, copy, nullable) NSString * toTime;
@property(nonatomic, assign) FlutterTransactionRequestType txnType;
@property(nonatomic, strong, nullable) NSNumber * page;
@property(nonatomic, strong, nullable) NSNumber * pageSize;
@end

@interface FlutterTransactionHistoryResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code
    transactionHistory:(nullable FlutterTransactionHistory *)transactionHistory;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, strong, nullable) FlutterTransactionHistory * transactionHistory;
@end

@interface FlutterTransactionHistory : NSObject
+ (instancetype)makeWithTransactions:(nullable NSArray<FlutterTransaction *> *)transactions
    pagination:(nullable FlutterPagination *)pagination;
@property(nonatomic, strong, nullable) NSArray<FlutterTransaction *> * transactions;
@property(nonatomic, strong, nullable) FlutterPagination * pagination;
@end

@interface FlutterTransaction : NSObject
+ (instancetype)makeWithId:(nullable NSString *)id
    refId:(nullable NSString *)refId
    orderCode:(nullable NSString *)orderCode
    txnType:(FlutterTransactionType)txnType
    txnTypeText:(nullable NSString *)txnTypeText
    txnDesc:(nullable NSString *)txnDesc
    accountingType:(FlutterAccountingType)accountingType
    status:(FlutterStatus)status
    point:(nullable NSNumber *)point
    createdAt:(nullable NSNumber *)createdAt
    networkId:(nullable NSNumber *)networkId
    networkName:(nullable NSString *)networkName
    merchantCode:(nullable NSString *)merchantCode
    merchantName:(nullable NSString *)merchantName;
@property(nonatomic, copy, nullable) NSString * id;
@property(nonatomic, copy, nullable) NSString * refId;
@property(nonatomic, copy, nullable) NSString * orderCode;
@property(nonatomic, assign) FlutterTransactionType txnType;
@property(nonatomic, copy, nullable) NSString * txnTypeText;
@property(nonatomic, copy, nullable) NSString * txnDesc;
@property(nonatomic, assign) FlutterAccountingType accountingType;
@property(nonatomic, assign) FlutterStatus status;
@property(nonatomic, strong, nullable) NSNumber * point;
@property(nonatomic, strong, nullable) NSNumber * createdAt;
@property(nonatomic, strong, nullable) NSNumber * networkId;
@property(nonatomic, copy, nullable) NSString * networkName;
@property(nonatomic, copy, nullable) NSString * merchantCode;
@property(nonatomic, copy, nullable) NSString * merchantName;
@end

@interface FlutterPagination : NSObject
+ (instancetype)makeWithPage:(nullable NSNumber *)page
    pageSize:(nullable NSNumber *)pageSize
    totalItems:(nullable NSNumber *)totalItems;
@property(nonatomic, strong, nullable) NSNumber * page;
@property(nonatomic, strong, nullable) NSNumber * pageSize;
@property(nonatomic, strong, nullable) NSNumber * totalItems;
@end

@interface FlutterNetworkConfigResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code
    networkConfig:(nullable FlutterNetworkConfig *)networkConfig;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, strong, nullable) FlutterNetworkConfig * networkConfig;
@end

@interface FlutterNetworkConfig : NSObject
+ (instancetype)makeWithNetworkId:(nullable NSString *)networkId
    networkName:(nullable NSString *)networkName
    exchangeRate:(nullable NSNumber *)exchangeRate
    currencyImg:(nullable NSString *)currencyImg
    currencyName:(nullable NSString *)currencyName
    cardDefaultImg:(nullable NSString *)cardDefaultImg
    avatarDefaultImg:(nullable NSString *)avatarDefaultImg
    allowToGetMemberByPhone:(nullable NSNumber *)allowToGetMemberByPhone
    faqWebUrl:(nullable NSString *)faqWebUrl
    benefitWebUrl:(nullable NSString *)benefitWebUrl
    brandColor:(nullable NSString *)brandColor
    allowMerchantIssueMemberCard:(nullable NSNumber *)allowMerchantIssueMemberCard
    networkTiers:(nullable NSArray<FlutterTier *> *)networkTiers;
@property(nonatomic, copy, nullable) NSString * networkId;
@property(nonatomic, copy, nullable) NSString * networkName;
@property(nonatomic, strong, nullable) NSNumber * exchangeRate;
@property(nonatomic, copy, nullable) NSString * currencyImg;
@property(nonatomic, copy, nullable) NSString * currencyName;
@property(nonatomic, copy, nullable) NSString * cardDefaultImg;
@property(nonatomic, copy, nullable) NSString * avatarDefaultImg;
@property(nonatomic, strong, nullable) NSNumber * allowToGetMemberByPhone;
@property(nonatomic, copy, nullable) NSString * faqWebUrl;
@property(nonatomic, copy, nullable) NSString * benefitWebUrl;
@property(nonatomic, copy, nullable) NSString * brandColor;
@property(nonatomic, strong, nullable) NSNumber * allowMerchantIssueMemberCard;
@property(nonatomic, strong, nullable) NSArray<FlutterTier *> * networkTiers;
@end

@interface FlutterTier : NSObject
+ (instancetype)makeWithCode:(nullable NSString *)code
    name:(nullable NSString *)name
    fromPoint:(nullable NSNumber *)fromPoint
    cardTieredImg:(nullable NSString *)cardTieredImg
    tierIconImg:(nullable NSString *)tierIconImg;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, copy, nullable) NSString * name;
@property(nonatomic, strong, nullable) NSNumber * fromPoint;
@property(nonatomic, copy, nullable) NSString * cardTieredImg;
@property(nonatomic, copy, nullable) NSString * tierIconImg;
@end

@interface FlutterClientIdResult : NSObject
+ (instancetype)makeWithError:(nullable NSString *)error
    code:(nullable NSString *)code
    clientId:(nullable NSString *)clientId;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, copy, nullable) NSString * code;
@property(nonatomic, copy, nullable) NSString * clientId;
@end

/// The codec used by FlutterLoyaltyApi.
NSObject<FlutterMessageCodec> *FlutterLoyaltyApiGetCodec(void);

@protocol FlutterLoyaltyApi
/// @return `nil` only when `error != nil`.
- (nullable CommonResult *)getInstanceAppName:(NSString *)appName error:(FlutterError *_Nullable *_Nonnull)error;
- (void)getConfigurationAppName:(NSString *)appName completion:(void(^)(FlutterLoyaltyConfigurationResult *_Nullable, FlutterError *_Nullable))completion;
- (void)registerMemberAppName:(NSString *)appName request:(FlutterRegisterMemberRequest *)request completion:(void(^)(FlutterRegisterMemberResult *_Nullable, FlutterError *_Nullable))completion;
- (void)getMembershipQrAppName:(NSString *)appName completion:(void(^)(FlutterMembershipQrResult *_Nullable, FlutterError *_Nullable))completion;
- (void)getMemberInfoAppName:(NSString *)appName request:(FlutterMemberInfoRequest *)request completion:(void(^)(FlutterMemberInfoResult *_Nullable, FlutterError *_Nullable))completion;
- (void)getTransactionHistoryAppName:(NSString *)appName request:(FlutterTransactionHistoryRequest *)request completion:(void(^)(FlutterTransactionHistoryResult *_Nullable, FlutterError *_Nullable))completion;
- (void)getNetworkConfigAppName:(NSString *)appName completion:(void(^)(FlutterNetworkConfigResult *_Nullable, FlutterError *_Nullable))completion;
- (void)getClientIdAppName:(NSString *)appName completion:(void(^)(FlutterClientIdResult *_Nullable, FlutterError *_Nullable))completion;
- (void)assignMemberCardIdAppName:(NSString *)appName memberId:(NSString *)memberId memberCardId:(NSString *)memberCardId completion:(void(^)(CommonResult *_Nullable, FlutterError *_Nullable))completion;
@end

extern void FlutterLoyaltyApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<FlutterLoyaltyApi> *_Nullable api);

NS_ASSUME_NONNULL_END
