import 'dart:core';

class LoyaltyCoreException implements Exception {
  final String? message;

  LoyaltyCoreException(this.message);
}

class MissingDataException extends LoyaltyCoreException {
  MissingDataException() : super("Missing data error");
}

class InvalidParamFormatException extends LoyaltyCoreException {
  InvalidParamFormatException(String? message) : super(message);
}

class ParamOutOfRangeException extends LoyaltyCoreException {
  ParamOutOfRangeException(String? message) : super(message);
}

class MissingParamException extends LoyaltyCoreException {
  MissingParamException(String? message) : super(message);
}

class InvalidParamException extends LoyaltyCoreException {
  InvalidParamException(String? message) : super(message);
}

class UnauthorizedException extends LoyaltyCoreException {
  UnauthorizedException(String? message) : super(message);
}

class PermissionDenied extends LoyaltyCoreException {
  PermissionDenied(String? message) : super(message);
}

class SubjectNotFoundException extends LoyaltyCoreException {
  SubjectNotFoundException(String? message) : super(message);
}

class MemberNotMatchException extends LoyaltyCoreException {
  MemberNotMatchException(String? message) : super(message);
}

class RedemptionCodeExpired extends LoyaltyCoreException {
  RedemptionCodeExpired(String? message) : super(message);
}

class MemberInactiveException extends LoyaltyCoreException {
  MemberInactiveException(String? message) : super(message);
}

class MemberQrCodeInactiveException extends LoyaltyCoreException {
  MemberQrCodeInactiveException(String? message) : super(message);
}

class DataInactiveException extends LoyaltyCoreException {
  DataInactiveException(String? message) : super(message);
}

class NetworkInactiveException extends LoyaltyCoreException {
  NetworkInactiveException(String? message) : super(message);
}

class ServerErrorException extends LoyaltyCoreException {
  ServerErrorException(String? message) : super(message);
}

class CannotCallLoyaltyServiceException extends LoyaltyCoreException {
  CannotCallLoyaltyServiceException(String? message) : super(message);
}

class DuplicateMemberCardIdException extends LoyaltyCoreException {
  DuplicateMemberCardIdException(String? message) : super(message);
}

class DuplicatePhoneNumberException extends LoyaltyCoreException {
  DuplicatePhoneNumberException(String? message) : super(message);
}
