class NetworkConfig {
  final String networkId;
  final String networkName;
  final int exchangeRate;
  final String currencyImg;
  final String currencyName;
  final String? cardDefaultImg;
  final String? avatarDefaultImg;
  final bool allowToGetMemberByPhone;
  final String? faqWebUrl;
  final String? benefitWebUrl;
  final String? brandColor;
  final bool allowMerchantIssueMemberCard;
  final List<Tier>? networkTiers;

  NetworkConfig({
    required this.networkId,
    required this.networkName,
    required this.exchangeRate,
    required this.currencyImg,
    required this.currencyName,
    required this.cardDefaultImg,
    required this.avatarDefaultImg,
    required this.allowToGetMemberByPhone,
    required this.faqWebUrl,
    required this.benefitWebUrl,
    required this.brandColor,
    required this.allowMerchantIssueMemberCard,
    required this.networkTiers,
  });
}

class Tier {
  final String code;
  final String name;
  final int fromPoint;
  final String? cardTieredImg;
  final String? tierIconImg;

  Tier({
    required this.code,
    required this.name,
    required this.fromPoint,
    required this.cardTieredImg,
    required this.tierIconImg,
  });
}
