import 'status.dart';
import 'transaction_type.dart';

class TransactionHistory {
  final List<Transaction> transactions;
  final Pagination pagination;

  TransactionHistory({
    required this.transactions,
    required this.pagination,
  });
}

class Transaction {
  final String id;
  final String? refId;
  final String? orderCode;
  final TransactionType txnType; // init
  final String txnTypeText;
  final String? txnDesc;
  final AccountingType accountingType; // credit
  final Status? status; //init
  final int point;
  final int createdAt;
  final int networkId;
  final String networkName;
  final String? merchantCode;
  final String? merchantName;

  Transaction({
    required this.id,
    required this.refId,
    required this.orderCode,
    required this.txnType,
    required this.txnTypeText,
    required this.txnDesc,
    required this.accountingType,
    required this.status,
    required this.point,
    required this.createdAt,
    required this.networkId,
    required this.networkName,
    required this.merchantCode,
    required this.merchantName,
  });
}

enum AccountingType { debit, credit }

class Pagination {
  final int page;
  final int pageSize;
  final int totalItems;

  Pagination({
    required this.page,
    required this.pageSize,
    required this.totalItems,
  });
}
